(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
/*
	Copyright 2018 [4ddev *see github.com/4ddev]

	Permission is hereby granted, free of charge, to any person obtaining a copy 
	of this software and associated documentation files (the "Software"), 
	to deal in the Software without restriction, including without limitation 
	the rights to use, copy, modify, merge, publish, distribute, sublicense, 
	and/or sell copies of the Software, and to permit persons to whom the Software 
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be 
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
	IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
	DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
	OTHER DEALINGS IN THE SOFTWARE.
*/
// DEMO
class Message{
   constructor(content){
	   this.content = content;
   }
   execute(){
	   return "Message";
   }
}

class UpdateUserMessage extends Message {
   constructor( content ){
	  super( content );
   }
   // @Override 
   execute(){
	  return this.content;
   }
}	

class DemoNotAllowed extends Message {
   constructor( content ){
	  super( content );
   }
   // @Override 
   execute(){
	  return this.content;
   }
}	

class DeleteUserMessage extends Message {
   constructor( content ){
	  super( content );
   }
   // @Override 
   execute(){
	  return this.content;
   }
}

module.exports = {
	DeleteUserMessage: DeleteUserMessage,
	UpdateUserMessage: UpdateUserMessage,
	DemoNotAllowed: DemoNotAllowed,
	Message: Message
}

},{}],2:[function(require,module,exports){
var Types = require( './MessageTypes.js' );
var MessageController = require( 'message-controller' );
var HandleMessage = MessageController.HandleMessage;

var messages = [];
const construct = Types;

// SEND 
// Create some Objects which have some attributes
let someObjectFF = new Types.UpdateUserMessage({a:"Update"});
let someObjectF = new Types.DeleteUserMessage("DEMO");
let some = new Types.DemoNotAllowed();

// Generate the String of the JSON - the Object will be wrapped with the classtype * -->
let json = HandleMessage.wrapMessage(someObjectFF);
let json2 = HandleMessage.wrapMessage(someObjectF);
let json3 = HandleMessage.wrapMessage(some);

var messageBuffer = [ json,json2,json3 ];

console.log( "The Generated Message: ", json );
console.log( "The Generated Message: ", json2 );
console.log( "The Generated Message: ", json3 );


// Establish connection to some Server - in this case Demo Server 
var connection = new WebSocket('ws://localhost:8080');
// When the connection is open, send some data to the server
connection.onopen = function () {
  connection.send(messageBuffer.pop()); // Send the message 'Ping' to the server
};

// Log errors
connection.onerror = function (error) {
  console.log('WebSocket Error ' + error);
};

// Log messages from the server
connection.onmessage = function (e) {
  console.log('Server: ' + e.data);
  if( messageBuffer.length > 0 ) connection.send( messageBuffer.pop() );
};

},{"./MessageTypes.js":1,"message-controller":3}],3:[function(require,module,exports){
/*
	Copyright 2018 [4ddev *see github.com/4ddev]

	Permission is hereby granted, free of charge, to any person obtaining a copy 
	of this software and associated documentation files (the "Software"), 
	to deal in the Software without restriction, including without limitation 
	the rights to use, copy, modify, merge, publish, distribute, sublicense, 
	and/or sell copies of the Software, and to permit persons to whom the Software 
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be 
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
	IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
	DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
	OTHER DEALINGS IN THE SOFTWARE.
*/
class Set{
	constructor(){
		this.keys = [];
	}
	// Stores Classes
	put(){
		for( let i = 0; i < arguments.length; i++){
		   if( arguments[i].name != null ) this.keys[arguments[i].name] = arguments[i];
		}
		return this;
	}
	contains( obj ){
		return this.keys[obj]!=null;
	}
	
	remove( obj ){
		this.keys[obj] = null;
		delete this.keys[obj];
	}
	get( key ){
		return this.keys[key];
	}
}

class HandleMessage{
	/* Does not attach function's or their return values just atomic values */
	static wrapMessage( obj ){
		return JSON.stringify( { type: obj.constructor.name, body: Object.assign( {},obj ) } );
	}
	/*
	   @param json Some Object or an String which will be parsed to an Object by json.parse 
	   @param classes Check's incoming Message against this ClassSet if no class with the name was 
	                  found, it will remove null 
       @return null If the class was not found
	           Object The instantianted Object in the Classlist 
	*/			   
	static createInstance(json,classes){
		if ( json.constructor.name == "String" ){ json = JSON.parse(json); }
		
		if (classes.contains(json.type.toString()) ) { 
			return Object.assign(new (classes.get(json.type))(),json.body); 
		}
		return null;
		//throw new Error("Method is not allowed "+json.type.toString());  // Use this if you wanna have an exception 
	}
}

module.exports = {
	HandleMessage: HandleMessage,
	ClassSet: Set,
	createInstance: HandleMessage.createInstance,
	wrapMessage: HandleMessage.wrapMessage,
}
},{}]},{},[2]);
